#property copyright "lseder@gmail.com"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Red

extern datetime fromDay = D'01.05.2009';
extern datetime toDay = D'01.08.2009';

extern int cci_period = 27;

extern int minProfit = 100;
extern int maxProfit = 1100;

extern int minLoss = 120;
extern int maxLoss = 1120;


extern int logLoss = 520;
extern int logProfit = 1000;
extern bool isLog = false;


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];


bool calcOnce = false;

int b[20][10][3];//b[profit][loss][0] - balance; ..[1] - index of tick with opened order


double cci(int index){
double d =  iCCI(Symbol(), 0, cci_period, PRICE_TYPICAL, index);
 return( d );
}

// ***************************************************************************
// 

int is_buy(int check_tick){
 int i=0;
  if(
  cci(check_tick+1)<5 && 
  cci(check_tick+2)<cci(check_tick+3) && 
  cci(check_tick+1)<cci(check_tick+2) && 
  cci(check_tick+0)>cci(check_tick+1) && 
  Open[check_tick+2]>Close[check_tick+2] && 
  Open[check_tick+1]>Close[check_tick+1] && 
  Open[check_tick+0]<Close[check_tick+0] && 
  Open[check_tick+1]<Close[check_tick+0]){ i = 1;}else{

  if(cci(check_tick+1)>5 && cci(check_tick+2)>cci(check_tick+3) && 
     cci(check_tick+1)>cci(check_tick+2) && cci(check_tick+0)<cci(check_tick+1) && 
   Open[check_tick+2]<Close[check_tick+2] && Open[check_tick+1]<Close[check_tick+1] && 
   Open[check_tick+0]>Close[check_tick+0] && Open[check_tick+1]>Close[check_tick+0])i=-1;
   
  }
  
 return( i );
}
// ---------------------------------------------------------------------------

int mapRange(int minR,int maxR,int count,int mapValue,bool reverse=false,bool log=false){
int r = -1;
if (reverse==true){
 if(mapValue<0)return(-1);
 if(mapValue>=count)return(-1);
 r = (mapValue)*(maxR-minR)/count+minR;
}else{ 
 if(mapValue<minR)return(-1);
 if(mapValue>maxR)return(-1);
 double d = (maxR-minR);
 d = count*(mapValue - minR)/d;
 r = d;
}
return( r );
}



void calc_balance(){
int i,j,k,t,z,ss;
t = Bars;
 //zero balance matrix
for(i=19;i>=0;i--)for(j=9;j>=0;j--){b[i][j][0] = 0;b[i][j][1] = t;b[i][j][2] = 0;}
 
 logProfit = mapRange(minProfit,maxProfit,20,logProfit);
 logLoss = mapRange(minLoss,maxLoss,10,logLoss);
 
for(i=Bars-1;i>0;i--){
 //check each tick
 if ((Time[i]>=fromDay)&&(Time[i]<=toDay)){//only selected date range
 ss = is_buy(i+1);
 if (ss != 0){
   
  // loop down - calc profit and loss in h
  j = i;
  int tmaxLoss = -1; int tmaxProfit = -1;
  while(j>=0){
  
   if(ss==1){//buy
   double tmp = NormalizeDouble(Low[j]-Open[i],6)*100000*ss; //loss?
   if (tmp>0)tmp = NormalizeDouble(High[j]-Open[i],6)*100000*ss;//profit
   }else{//sell
   tmp = NormalizeDouble(-High[j]+Open[i],6)*100000*ss; //loss?
   if (tmp>0)tmp = NormalizeDouble(-Low[j]+Open[i],6)*100000*ss;//profit
   }

   tmp =  tmp - 10; //spread

   
   int p = 0; int l = 0;
   
   if (tmp>0){
    p = mapRange(minProfit,maxProfit,20,tmp,false,true); 
    if (p>tmaxProfit){
     //close cell with profit p
     for(k=tmaxLoss+1;k<=9;k++)
     for(t=tmaxProfit+1;t<=p;t++)
     {
      if (i<b[t][k][1])
      {
       z = mapRange(minProfit,maxProfit,20,t,true);      
       b[t][k][1] = j;
       b[t][k][0] = b[t][k][0] + z;
       
       if (isLog)
       if ((logLoss==k)&&(logProfit==t))
        Print("p:",z,", b:",b[t][k][0],",i:",
         TimeToStr(Time[i],TIME_DATE|TIME_SECONDS),",j:",
         TimeToStr(Time[j],TIME_DATE|TIME_SECONDS),",tmp:",tmp,
         ",Open[i]:",DoubleToStr(Open[i],6),",High[j]:",DoubleToStr(High[j],6));
         
      }
     } 
     tmaxProfit = p; 


    }
   }else{
   //loss
    tmp=-tmp;
    l = mapRange(minLoss,maxLoss,10,tmp);//loss
    
    if (l>tmaxLoss){
     //add loss l 
     for(k=tmaxLoss+1;k<=l;k++)
     for(t=tmaxProfit+1;t<=19;t++){
      if (i<b[t][k][1])
      {
       z = mapRange(minLoss,maxLoss,10,k,true);
       b[t][k][1] = j;
       b[t][k][0] = b[t][k][0] - z;
       
       if (b[t][k][0]<b[t][k][2])b[t][k][2] = b[t][k][0];//save max drawdown
       
       if (isLog)
       if ((logLoss==k)&&(logProfit==t))
        Print("l:",-z,", b:",b[t][k][0],",i:",
         TimeToStr(Time[i],TIME_DATE|TIME_SECONDS),",j:",
         TimeToStr(Time[j],TIME_DATE|TIME_SECONDS),",tmp:",tmp,
         ",Open[i]:",Open[i],",Open[j]:",Open[j]);
        
       
      }
     }
     tmaxLoss = l; 

     
    }
   }
  


   if ((tmaxLoss==9)||(tmaxProfit==19))break;//stop calc if out of grid
   j--;
  }//while j
   
 }//is_buy=1
}//time check
} 
calcOnce = true;
}

void draw_balance(double& indBuffer[], double& indBuffer2[],double& indBuffer3[],double& indBuffer4[]){
int k = 0;

for(int j=0;j<10;j++){
 for(int i=0;i<20;i++){
  //if (b[i][j][0]>0)//skip lower zero balance
  {
   indBuffer2[k] = mapRange(minLoss,maxLoss,10,j,true);
   indBuffer3[k] = mapRange(minProfit,maxProfit,20,i,true);
   indBuffer[k] = b[i][j][0];//balance
   indBuffer4[k] = b[i][j][2];//drawdown
   k++;
   }
  }
 }

 
}

int init()
  {
   calcOnce = false;
   IndicatorShortName("PLBalance: cci="+cci_period+", "+TimeToStr(fromDay)+"-"+TimeToStr(toDay));
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);

   SetIndexLabel(1,"StopLoss");
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,ExtMapBuffer2);

   SetIndexLabel(2,"TakeProfit");
   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,ExtMapBuffer4);
  
   SetIndexLabel(3,"MaxDrawDown");
   SetIndexStyle(3,DRAW_LINE );
   SetIndexBuffer(3,ExtMapBuffer3);

   return(0);
  }
int deinit()
  {
   return(0);
  }
  
int start()
  {
   if (!calcOnce) calc_balance();//draw once
   draw_balance(ExtMapBuffer1, ExtMapBuffer2, ExtMapBuffer4, ExtMapBuffer3);
   return(0);
  }
//+------------------------------------------------------------------+